/*
 * Application.h - by Alan Alvarez <alan.alvarez@us.army.mil>
 *
 * Mira GroupWare
 * Copyright (C) 2007-2008 Mira GroupWare Dev Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MIRACLIENT_APPLICATION_H
#define __MIRACLIENT_APPLICATION_H

#include "Client.h"
#include "User.h"
#include "MainWindow.h"
#include "GuiApp.h"

namespace miraclient
{

class Application
{
    public:
        typedef network::Client ClientType;

        static ClientType* get_client() { return m_client; }

        static gui::GuiApp* get_gui_application() { return dynamic_cast<gui::GuiApp*>(QApplication::instance()); }

        static bool set_client(ClientType* _client) 
        { 
            if (!m_client)
                m_client = _client;
            else
                return false;

            return true;
        }

        static void unset_client() 
        { 
            QMetaObject::invokeMethod(get_gui_application()->m_mainWindow, "serverConnectionLost", Qt::QueuedConnection);
            m_client = NULL;
        }


        static void start();

        static User              user_info;
    private:
        static network::Client*  m_client;
        static gui::MainWindow*  m_main_window;
};

}

#endif // __MIRASERVER_APPLICATION_H
