#ifndef CHATDOCKWIDGET_H
#define CHATDOCKWIDGET_H

#include <QDockWidget>
#include <QTextBrowser>
#include <QWidget>
#include <QLineEdit>


namespace miraclient
{

namespace gui
{

class ChatDockWidget : public QDockWidget
{
    Q_OBJECT
    public:
        ChatDockWidget();
        virtual ~ChatDockWidget();
    protected:
        void closeEvent(QCloseEvent * event);
    public slots:
		void FocusOnChat();
		void receiveMessage(std::string username, std::string message, std::string color="#FF0000");
		void receiveError(std::string errorMessage);
    signals:
        /*
            The default signals for a doc object only contain "visibilityChanged(bool)".
            If this is connected to the "Panes" menu items, then there is a hard crash when
            the dock widget is placed on top of another (to become a tabbed widget).
        //*/
        void closed(bool);
        void sendingMessage(std::string s);
    private slots:
		void sendMessage();
    private:
        void setupUI();
        QTextBrowser * m_chatBrowser;
        QWidget * m_mainChatWidget;
        QLineEdit * m_lineEdit;
};

}//end gui namespace
}//end miraclient namespace
#endif // CHATDOCKWIDGET_H
