#ifndef CONTACTDOCKWIDGET_H
#define CONTACTDOCKWIDGET_H

#include <QDockWidget>
#include <QTreeWidget>

namespace miraclient
{

namespace gui
{

class ContactDockWidget : public QDockWidget
{
    Q_OBJECT

    public:
        ContactDockWidget();
        virtual ~ContactDockWidget();
    protected:
        QTreeWidget * contactTree;
        void closeEvent(QCloseEvent * event);
    signals:
        /*
            The default signals for a doc object only contain "visibilityChanged(bool)".
            If this is connected to the "Panes" menu items, then there is a hard crash when
            the dock widget is placed on top of another (to become a tabbed widget).
        //*/
        void closed(bool);
    private slots:
        void UserStateChange();
    private:
        void setupUI();
        QTreeWidgetItem * activeTreeItem;
        QTreeWidgetItem * onlineTreeItem;
        QTreeWidgetItem * offlineTreeItem;
        int numActiveInWorkplace;
        int numOnlineInWorkplace;
        int numOfflineInWorkplace;
        int numTotalInWorkplace;
        void AddUser(QString username, int state);
};
} //end gui namespace
} //end miraclient namespace
#endif // CONTACTDOCKWIDGET_H
