#ifndef GuiApp_H
#define GuiApp_H

#include <QApplication>
#include <QtCore/QSettings>
#include <map>
#include "Workplace.h"
#include "MainWindow.h"

namespace miraclient
{

namespace gui
{


class GuiApp : public QApplication
{
    Q_OBJECT

    public:
        GuiApp(int& argc, char * argv[]);
        virtual ~GuiApp();
        void LoadWorkplaces();
        Workplace * getActiveWorkplace();
        Workplace * getWorkplace(std::string name);
        WorkplaceList getWorkplaces();
        void InitResources();
        void InitLocale();
        MainWindow * m_mainWindow;
        QSettings * m_settings;
    public slots:
        void setActiveWorkplace(Workplace * wp,Utility * util = NULL);
    private slots:
        void AddContact();
        void SendChatMessage(std::string s);
    signals:
		void AddedWorkplace(Workplace * wp);
		void ChangedWorkplace(Workplace * wp,Utility * util = NULL);
		void ReceiveChatMessage(std::string username, std::string msg);
		void ReceiveChatError(std::string errorMessage);
    protected:
    private:
		void AddWorkplace(Workplace * wp);
        WorkplaceList m_workplaces;
};
} //end gui namespace
} //end miraclient namespace
#endif // GuiApp_H
