#ifndef __MIRACLIENT_GUI_LOGINDIALOG_H
#define __MIRACLIENT_GUI_LOGINDIALOG_H

#include <QLineEdit>
#include <QDialog>
#include <QLabel>
#include <QFormLayout>
#include <QGroupBox>
#include <QPushButton>

namespace miraclient
{

namespace gui
{

class LoginDialog : public QDialog
{
   Q_OBJECT

    public:
        explicit LoginDialog(QWidget *parent = 0);
        ~LoginDialog() {}

        void loginFailed(const QString& error_message);

    private slots:
        void connectToServer();
        void cancel();
        void checkIfComplete();

    private:
        QVBoxLayout *m_mainLayout;
        QFormLayout *m_formLayout;
        QFormLayout *m_buttonsLayout;
        QGroupBox   *m_loginGroupBox;      

        QLabel      *m_errorLabel;

        QLineEdit   *m_usernameLineEdit;
        QLineEdit   *m_passwordLineEdit;
        QLineEdit   *m_serverLineEdit;
        QLineEdit   *m_portLineEdit;
        
        QPushButton *m_connectButton;
        QPushButton *m_cancelButton;
};

} // gui

} // miraclient

#endif // __MIRACLIENT_GUI_LOGINDIALOG_H
