#ifndef NAVIGATIONDOCKWIDGET_H
#define NAVIGATIONDOCKWIDGET_H

#include <QDockWidget>
#include <QTreeWidget>
#include "Workplace.h"

namespace miraclient
{

namespace gui
{

class NavigationDockWidget : public QDockWidget
{
    Q_OBJECT
    public:
        NavigationDockWidget();
        virtual ~NavigationDockWidget();
    public slots:
        void AddWorkplace(Workplace * wp);
        void changeWorkplaceSelection();
    protected:
        void closeEvent(QCloseEvent * event);
    signals:
        /*
            The default signals for a doc object only contain "visibilityChanged(bool)".
            If this is connected to the "Panes" menu items, then there is a hard crash when
            the dock widget is placed on top of another (to become a tabbed widget).
        //*/
        void closed(bool);
        void changedWorkplace(Workplace * wp,Utility * util = NULL);
    private:
        QTreeWidget * navigationTree;
        void setupUI();
};
} //end gui namespace
} //end miraclient
#endif // NAVIGATIONDOCKWIDGET_H
