#ifndef WORKPLACEWIDGET_H
#define WORKPLACEWIDGET_H

#include <QLabel>
#include <QWidget>
#include <QMap>
#include <QList>
#include <QVBoxLayout>
#include <QTabWidget>
#include "Workplace.h"

namespace miraclient
{

namespace gui
{

class WorkplaceWidget : public QWidget
{
	Q_OBJECT

    public:
        WorkplaceWidget(miraclient::gui::Workplace * workplace);
        void setActiveUtility(Utility * util);
        virtual ~WorkplaceWidget();
        std::string getName();
        Workplace * getWorkplace();
        void setActiveWorkplace(Workplace * wp,Utility * util = NULL);
    protected:
    private:
        QLabel * m_workplaceLabel;
        miraclient::gui::Workplace * m_workplace;
        QTabWidget * m_mainWpWidget;
        QVBoxLayout * m_mainLayout;
        void setupUI();
        QMap <Utility *,int> m_utils;
        QList<QWidget *> m_tabList;

};
} //end gui namespace
} //end miraclient namespace
#endif // WORKPLACEWIDGET_H
