/*
 * Client.h - by Alan Alvarez <alan.alvarez@us.army.mil>
 *
 * Mira GroupWare
 * Copyright (C) 2007-2008 Mira GroupWare Dev Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MIRACLIENT__NETWORK_CLIENT_H
#define __MIRACLIENT__NETWORK_CLIENT_H

#include <string>
#include <queue>
#include <boost/system/error_code.hpp>

namespace miraclient {

namespace network {

class Client
{
    public:
        Client() {}
        virtual ~Client() {}

        virtual void connect(const std::string& hostname, const unsigned int port, const std::string& username, const std::string& password) = 0;
        virtual void send(const std::string& message) = 0;
        virtual void send(const char* message) = 0;

        virtual std::string get_remote_server_address() const { return m_remote_server_address; }

        virtual void disconnect() = 0;

    protected:
        std::string m_remote_server_address;

};

} // namespace network

} // namespace miraclient

#endif // __MIRACLIENT__NETWORK_CLIENT_H
