/*
 * MsgUserAccepted.h
 *
 * Mira GroupWare
 * Copyright (C) 2007-2008 Mira GroupWare Dev Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __MIRASERVER__NETWORK_MSGERROR_H
#define __MIRASERVER__NETWORK_MSGERROR_H

#include <string>
#include <boost/algorithm/string.hpp>
#include "Msg.h"
#include "Application.h"
#include "tools.h"

using std::vector;
using std::string;
using boost::algorithm::split;
using boost::algorithm::is_space;

namespace miraclient
{

namespace network
{

class MsgError : public Msg
{
    public:
        MsgError(const std::string& message) : Msg(message)
        {}

        virtual void run()
        {
            vector<string> content;
            split(content, m_message, is_space());

            switch (Msg::get_token(content[0].c_str()))
            {
                case Msg::LOGIN:
                    if (m_message.length() > 3)
                        QMetaObject::invokeMethod(Application::get_gui_application()->m_mainWindow, "loginFailed", Qt::QueuedConnection, MIRA_QT_GENERIC_ARG(const QString, QString(m_message.substr(2).c_str())));
                    else
                        QMetaObject::invokeMethod(Application::get_gui_application()->m_mainWindow, "loginFailed", Qt::QueuedConnection, MIRA_QT_GENERIC_ARG(const QString, QString("")));
            }
        }
};
} // namespace network

} // namespace miraclient

#endif // __MIRASERVER__NETWORK_MSGERROR_H
