/*
 * MsgLoginSuccessful.h - by Alan Alvarez <aalvarez@aliensoft.net>
 *
 * Mira GroupWare
 * Copyright (C) 2007-2009 Mira GroupWare Dev Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __MIRASERVER__NETWORK_MSGLOGINSUCCESSFUL_H
#define __MIRASERVER__NETWORK_MSGLOGINSUCCESSFUL_H

#include <string>
#include <QMetaType>

#include "Msg.h"
#include "Application.h"

namespace miraclient
{

namespace network
{

class MsgLoginSuccessful : public Msg
{
    public:
        MsgLoginSuccessful(const std::string& message) : Msg(message)
        {}

        virtual void run()
        {
            QMetaObject::invokeMethod(Application::get_gui_application()->m_mainWindow, "loginSuccessful", Qt::QueuedConnection);
        }
};
} // namespace network

} // namespace miraclient

#endif // __MIRASERVER__NETWORK_MSGLOGINSUCCESSFUL_H
