#include "ChatDockWidget.h"
#include <QVBoxLayout>
#include <QMessageBox>
#include <QString>
#include <string>
using namespace miraclient::gui;

ChatDockWidget::ChatDockWidget()
{
    //ctor
    setWindowTitle(tr("Chat"));
    m_mainChatWidget = new QWidget();
    setupUI();
    setWidget(m_mainChatWidget);
    connect(m_lineEdit,SIGNAL(returnPressed()),this,SLOT(sendMessage()));
}

ChatDockWidget::~ChatDockWidget()
{
    //dtor
	delete m_chatBrowser;
	delete m_lineEdit;
	delete m_mainChatWidget;
}

void ChatDockWidget::setupUI()
{
    QVBoxLayout * vboxLayout = new QVBoxLayout(m_mainChatWidget);
    vboxLayout->setContentsMargins(0, 0, 0, 0);
    m_chatBrowser = new QTextBrowser(m_mainChatWidget);
    m_chatBrowser->setOpenExternalLinks(true);

    vboxLayout->addWidget(m_chatBrowser);

    m_lineEdit = new QLineEdit(m_mainChatWidget);

    vboxLayout->addWidget(m_lineEdit);
}

void ChatDockWidget::closeEvent(QCloseEvent * event)
{
    emit closed(false);
}

void ChatDockWidget::sendMessage()
{
	QString s = m_lineEdit->displayText();
	emit sendingMessage(std::string(s.toStdString()));
	m_chatBrowser->insertHtml("<b><font color=\"#0000ff\">Me:</font></b>"+s+"<br />");
	m_lineEdit->clear();
}

void ChatDockWidget::receiveMessage(std::string username,std::string message, std::string color)
{
	//Create the message
	QString qUsername=username.c_str();
	QString qMessage=message.c_str();
	m_chatBrowser->insertHtml("<b><font color=\""+QString(color.c_str())+"\">"+qUsername+":</font></b>"+qMessage+"<br />");
}

void ChatDockWidget::receiveError(std::string errorMessage)
{
	//Create the message
	QString qMessage=errorMessage.c_str();
	m_chatBrowser->insertHtml("<font color=\"#CCCCCC\">--"+qMessage+"--</font><br />");
}

void ChatDockWidget::FocusOnChat()
{
	this->setVisible(true);
	m_lineEdit->setFocus();
}
