#define QT_NO_CAST_FROM_ASCII

#include "Application.h"
#include "GuiApp.h"
#include <QSplashScreen>
#include <QtCore/QTranslator>


int main (int argc, char * argv[])
{

    bool splashOn = true;
    miraclient::gui::GuiApp app(argc,argv);

    //load Mira
    QSplashScreen * splash = new QSplashScreen;
    Qt::Alignment displayLocation = Qt::AlignCenter | Qt::AlignBottom;
    int color = Qt::black;
    if (splashOn)
    {
        splash->setPixmap(QPixmap(QString::fromAscii(":/images/loading-splash.png")));
        splash->show();
        splash->showMessage(QObject::tr("Loading workplaces..."),displayLocation,color);
    }
    app.LoadWorkplaces();

    if (splashOn)
    {
        splash->showMessage(QObject::tr("Setting up main window..."),displayLocation,color);
    }

    if (splashOn)
    {
        splash->showMessage(QObject::tr("Loading Application..."),displayLocation,color);
    }
    miraclient::Application::start();
    app.m_mainWindow->show();

    if (splashOn)
    {
        splash->finish(app.m_mainWindow);
    }
    delete splash;

    return app.exec();
}
