/*
 * Application.h - by Alan Alvarez <alan.alvarez@us.army.mil>
 *
 * Mira GroupWare
 * Copyright (C) 2007-2008 Mira GroupWare Dev Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __MIRASERVER_APPLICATION_H
#define __MIRASERVER_APPLICATION_H

#include "Server.h"
#include "Directory.h"
#include "ConfigParser.h"

namespace miraserver
{

class Application
{
    public:
        typedef network::Server ServerType;
        typedef directory::Directory DirectoryType;
        typedef ConfigParser ConfigurationType;

        static DirectoryType& get_directory() { return *m_directory; }
        static ServerType& get_server() { return *m_server; }
        static ConfigurationType& get_configuration() { return *m_configuration; }

        static void set_directory(DirectoryType* _directory) { m_directory = _directory; }
        static void set_server(ServerType* _server) { m_server = _server; }
        static void set_configuration(ConfigurationType* _configuration) { m_configuration = _configuration; }

    private:
        static directory::Directory* m_directory;
        static network::Server*      m_server;
        static ConfigParser*         m_configuration;

};

}

#endif // __MIRASERVER_APPLICATION_H
