/*
 * MsgPing.h
 *
 * Mira GroupWare
 * Copyright (C) 2007-2008 Mira GroupWare Dev Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __MIRASERVER__NETWORK_MSGPING_H
#define __MIRASERVER__NETWORK_MSGPING_H

#include <string>
#include <sstream>
#include <vector>

#include "Msg.h"
#include "tools.h"

namespace miraserver
{

namespace network
{
class MsgPing : public Msg
{
    public:
        MsgPing(TcpConnection* source_connection, const std::string& message) : Msg(source_connection, message)
        {}

        virtual void run()
        {
            //Splitting message into fields
            vector<std::string> message_field = Split(m_message, " ");

            //Checking on minimum fields
            if(message_field.size() >= 1 )
            {
                string return_message = "PO ";
                return_message += message_field.at(0); 
                m_source_connection->send(return_message);
            }
            else
                m_source_connection->send("E PI Invalid Format");
        };

        ~MsgPing() {}

    private:
};

}

}

#endif // __MIRASERVER__NETWORK_MSGPING_H
