#ifndef _MIRASERVER_TOOLS_H
#define _MIRASERVER_TOOLS_H

#include <string>
#include <sstream>
#include <vector>

//NOTE: To avoid linker error of multiple definition of functions in this file 
//they are defined inline functions.
inline int StringToInt(const std::string &str)  // string to int
{
  std::stringstream strm(str);
  int rint;
  strm >> rint;

  return rint;
}

inline std::string IntToString(const int x)
{
   std::ostringstream o;
   if (o << x)
    {
      return o.str();
    }
   else
    {
    return "ERR";
    }
} // end IntToString()

inline std::vector<std::string> Split(const std::string &str, const std::string &delimiter)
{
    std::vector<std::string> field;
    size_t  start_pos, end_pos;

    if(str.empty())
        return field;    
    end_pos = 0;
    do
    {
        //Skip delimiters, postion of first non-delimiter 
        start_pos = str.find_first_not_of(delimiter, end_pos);
         
        //If the non-delimiter is double quote then skipp till the delimiter after the next double quote.
        if(str.compare(start_pos, 1, "\"") == 0)
        {
            end_pos = str.find_first_of("\"", start_pos+1);
            end_pos   = str.find_first_of(delimiter, end_pos);
        }
        else
        {
            //Position of first delimiter after start_pos
            end_pos   = str.find_first_of(delimiter, start_pos);
        }
        field.push_back(str.substr(start_pos, end_pos - start_pos));
    }while(end_pos != std::string::npos);


    return field;
}

#endif //_MIRASERVER_TOOLS_H
