/*
 * Crypto.cpp - by Alan Alvarez <alan.alvarez@us.army.mil>
 *
 * Mira GroupWare
 * Copyright (C) 2007-2008 Mira GroupWare Dev Team
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <string>
#include <sstream>
#include <iomanip>
#include <iostream>
#include <cstdlib>
#include <ctime>

#include "Crypto.h"
#include "MD5.h"

using std::string;
using std::stringstream;
using std::ends;
using std::cout;
using std::endl;

string Crypto::GenerateSalt()
{
srand(time(0));
static const char validChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.$*_";
string salt = "";
for( unsigned short int i = 0 ; i < 8 ; ++i )
        {
        int randNo = 1 + (int) (64.0 * rand() / (RAND_MAX + 1.0) );
        salt += validChars[ randNo ] ;
        }
return salt;
}

// Extracted from gnuworld project cservice::CryptPass.
string Crypto::Encrypt(const string& plaintext, const string& salt)
{

/* Work out a MD5 hash of our salt + password */
md5             hash; // MD5 hash algorithm object.
md5Digest       digest; // MD5Digest algorithm object.

stringstream output;
string newPass;
newPass = salt + plaintext;

hash.update( (const unsigned char *)newPass.c_str(),
        newPass.size() );
hash.report( digest );

/* Convert to Hex */
int data[ MD5_DIGEST_LENGTH ] = { 0 } ;
for( size_t ii = 0; ii < MD5_DIGEST_LENGTH; ii++ )
        {
        data[ii] = digest[ii];
        }

output << std::hex;
output.fill('0');
for( size_t ii = 0; ii < MD5_DIGEST_LENGTH; ii++ )
        {
        output << std::setw(2) << data[ii];
        }
output << ends;

return output.str();
}
