#include "MsgQuery.h"
#include "WorkPlace.h"
#include "Field.h"
#include "User.h"
#include "Application.h"
#include "field_defs.h"

#include <string>
#include <list>

using std::string;

namespace miraserver
{

namespace network
{

void MsgQuery::query_groups(const std::string& query)
{
   string message;
   std::vector<std::string> message_field = Split(query, " ");

   if(message_field.size() >= 2)
   {
       WorkPlace group;
       Field field;
       User user;
       std::list<std::string>::iterator it;

       //If the message is G * then all the workgroups are displayed.
        if(message_field.size() == 2)
        {
            //This will only work if the group_ids are sequential.
            unsigned int group_id = 1;
            group = Application::get_directory().find_workplace(group_id);
            message = "G ";
            while(group.is_valid())
            {
                field = group.get_field(ATTRIBUTE_USER_LIST);
                if(field.type != Field::type_invalid)
                {
                    message += group.get_workplace_name() + " ";
                    for(it = field.value_list.begin(); it != field.value_list.end();)
                    {
                        user = Application::get_directory().find_user(StringToInt(*it));
                        message += user.get_username();
                        if(++it != field.value_list.end())
                            message += ",";
                    }
                    message += "\n";
                }
                group = Application::get_directory().find_workplace(++group_id);
            }
            m_source_connection->send(message);
        }
        else
        {
            string group_name;
            
            //For message  eg,G * GroupName=Mira
            size_t pos = message_field.at(2).find("=");
            if(pos != string::npos)
                group_name = message_field.at(2).substr(pos+1);
            else
               group_name = message_field.at(2);
 
            group = Application::get_directory().find_workplace(group_name);
            if(group.is_valid())
            {
                field = group.get_field(ATTRIBUTE_USER_LIST);
                if(field.type != Field::type_invalid)
                {
                    message = "G ";
                    message += group.get_workplace_name() + " ";
                    for(it = field.value_list.begin(); it != field.value_list.end();)
                    {
                        user = Application::get_directory().find_user(StringToInt(*it));
                        message += user.get_username();
                        if(++it != field.value_list.end())
                            message += ",";
                    }

                }
                m_source_connection->send(message);
            }
            else
            {
                std::string error_message = "E G group ";
                error_message += group_name + " not found";
                m_source_connection->send(error_message);
            }
        }
    }
    else
    {
        m_source_connection->send("E G Invalid Format");
    }
}

void MsgQuery::query_users(const std::string& query)
{
    // TODO
}

std::map<string,MsgQuery::FirstField> MsgQuery::m_field_map = FieldMap();

} // namespace network

} // namespace miraserver
